#!/usr/bin/tclsh

# Main proc at the end #

#------------------------------------------------------------------------------
proc vhdl_compil { } {
  global Path_VHDL
  global Path_TB
  puts "\nVHDL compilation :"


  vcom $Path_VHDL/ConfigurationPackage.vhd
  vcom $Path_VHDL/GenericFullAdder.vhd
  vcom $Path_VHDL/bcd_pkg.vhd
  vcom $Path_VHDL/bcd_adder.vhd
  vcom $Path_TB/bcd_adder_tb.vhd
}

#------------------------------------------------------------------------------
proc sim_start {errno} {

  vsim -t 1ns -GERRNO=$errno -novopt work.bcd_adder_tb

#  do wave.do
  add wave -r *
  wave refresh
  run -all
  #wave zoom full
}

#------------------------------------------------------------------------------
proc do_all {errno} {
  vhdl_compil
  sim_start $errno
}

## MAIN #######################################################################

# Compile folder ----------------------------------------------------
if {[file exists work] == 0} {
  vlib work
}

puts -nonewline "  Path_VHDL => "
set Path_VHDL     "../src"
set Path_TB       "../src_tb"

global Path_VHDL
global Path_TB

# start of sequence -------------------------------------------------

if {$argc > 0} {
  if {[string compare $1 "all"] == 0} {
    if {$argc > 1} {
        do_all $2
    } else {
      do_all 0
    }
  } elseif {[string compare $1 "comp_vhdl"] == 0} {
    vhdl_compil
  } elseif {[string compare $1 "sim"] == 0} {
    sim_start
  }

} else {
  do_all 0
}
